<?php
$servername = "localhost";
$username = "sat";
$password = "cL6cR7kC8w";
$dbname = "sat";

// Название таблицы Links
$linksTable = "`Links - uberg.ru`";

// Функция для преобразования формата даты
function transformDate($date) {
    if (preg_match('/\\d{2}\\.\\д{2}\\.\\д{4}/', $date)) {
        $parts = explode('.', $date);
        return "{$parts[2]}-{$parts[1]}-{$parts[0]}";
    }
    return $date;
}

// Функция для проверки и отдачи содержимого robots.txt
function serveRobotsTxt() {
    header('Content-Type: text/plain');
    echo "User-agent: *\n";
    echo "Disallow: /\n\n";
    echo "User-Agent: GoogleBot\n";
    echo "Allow: /\n\n";
    echo "User-Agent: Yandex\n";
    echo "Allow: /\n";
    exit;
}

// Проверка, если запрашивается robots.txt
if ($_SERVER['REQUEST_URI'] === '/robots.txt') {
    serveRobotsTxt();
}

// Функции для работы с кешем
function getCache($key) {
    $cacheFile = __DIR__ . "/cache/$key.json";
    if (file_exists($cacheFile) && (filemtime($cacheFile) > (time() - 24 * 60 * 60))) { // кэш живет 24 часа
        $data = file_get_contents($cacheFile);
        return json_decode($data, true);
    }
    return false;
}

function setCache($key, $data) {
    $cacheFile = __DIR__ . "/cache/$key.json";
    if (!file_exists(__DIR__ . "/cache")) {
        mkdir(__DIR__ . "/cache", 0777, true);
    }
    file_put_contents($cacheFile, json_encode($data));
}

function clearCache($key) {
    $cacheFile = __DIR__ . "/cache/$key.json";
    if (file_exists($cacheFile)) {
        unlink($cacheFile);
    }
}

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Функция для выбора случайной строки из таблицы
    function getRandomRow($conn, $table) {
        $cacheKey = "random_row_$table";
        $row = getCache($cacheKey);
        if ($row === false) {
            $stmt = $conn->query("SELECT * FROM $table ORDER BY RAND() LIMIT 1");
            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            setCache($cacheKey, $row);
        }
        return $row;
    }

    // Функция для выбора случайных строк из таблицы
    function getRandomRows($conn, $table) {
        $cacheKey = "random_rows_$table";
        $rows = getCache($cacheKey);
        if ($rows === false) {
            $limit = rand(10, 30);
            $stmt = $conn->query("SELECT * FROM $table ORDER BY RAND() LIMIT $limit");
            $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
            setCache($cacheKey, $rows);
        }
        return $rows;
    }

    // Функции для генерации случайных данных
    function generateRandomCreditLimit() {
        $limits = [50000, 100000, 150000, 200000, 250000, 300000, 350000, 400000, 450000, 500000];
        return number_format($limits[array_rand($limits)], 0, '', ' ') . " рублей";
    }

    function generateRandomGracePeriod() {
        $periods = [50, 60, 90, 120];
        return $periods[array_rand($periods)] . " дней";
    }

    function generateRandomAnnualFee() {
        return rand(5, 50) * 100 . " рублей";
    }

    function generateRandomInterestRate() {
        return rand(10, 30) . "%";
    }

    function generateRandomCashback() {
        return rand(1, 10) . "%";
    }

    function generateRandomMaxLoanAmount() {
        $amounts = [10000, 20000, 30000, 40000, 50000, 60000, 70000, 80000, 90000, 100000];
        return number_format($amounts[array_rand($amounts)], 0, '', ' ') . " рублей";
    }

    function generateRandomLoanTerm() {
        $terms = [7, 14, 30, 60, 90, 120];
        return $terms[array_rand($terms)] . " дней";
    }

    function generateRandomInsurancePolicyPrice() {
        return number_format(rand(50, 200) * 1000, 0, '', ' ') . " рублей";
    }

    // Функция для генерации случайного текста для банков
    function generateRandomBankText($conn, $banks, $randomKey) {
        $phrases = [
            "Если вы хотите открыть кредитную карту в банке %s, то вы можете получить кредитный лимит до %s. Годовое обслуживание вам обойдется в %s. Льготный период составляет %s, а процентная ставка равна %s. Кроме того, вы можете получить кэшбэк до %s.",
            "Кредитные карты банка %s предлагают кредитный лимит до %s. За годовое обслуживание придется заплатить %s. Льготный период - %s, процентная ставка - %s. Также доступен кэшбэк в размере %s.",
            "Банк %s предлагает кредитные карты с кредитным лимитом до %s. Годовое обслуживание стоит %s. Льготный период составляет %s, процентная ставка равна %s, а кэшбэк до %s."
        ];

        $text = "";
        while (strlen($text) < 3000) {
            $bank = $banks[array_rand($banks)];
            $text .= sprintf(
                $phrases[array_rand($phrases)],
                $bank['Банк'],
                generateRandomCreditLimit(),
                generateRandomAnnualFee(),
                generateRandomGracePeriod(),
                generateRandomInterestRate(),
                generateRandomCashback()
            ) . " ";
        }

        // Разделение текста на два блока для вставки заголовка h3 после завершения предложения
        $middlePos = strrpos(substr($text, 0, strlen($text) / 2), '.');
        $text = substr($text, 0, $middlePos + 1) . "<h3>$randomKey</h3>" . substr($text, $middlePos + 1);

        // Добавление второго заголовка h3 перед маркированным списком
        $randomKey2 = getRandomRow($conn, 'Key_Banks')['Ключ'];
        $text .= "<h3>$randomKey2</h3>";

        // С вероятностью 30% добавить заголовок h4
        if (rand(1, 100) <= 30) {
            $randomKey3 = getRandomRow($conn, 'Key_Banks')['Ключ'];
            $text .= "<h4>$randomKey3</h4>";
        }

        // Добавление маркированного списка
        $listItems = [
            "<li>Кредитный лимит: " . generateRandomCreditLimit() . "</li>",
            "<li>Льготный период: " . generateRandomGracePeriod() . "</li>",
            "<li>Годовое обслуживание: " . generateRandomAnnualFee() . "</li>",
            "<li>Процентная ставка: " . generateRandomInterestRate() . "</li>",
            "<li>Кэшбэк: " . generateRandomCashback() . "</li>"
        ];
        shuffle($listItems);
        $text .= "<ul>" . implode("", $listItems) . "</ul>";

        return $text;
    }

    // Функция для генерации случайного текста для займов
    function generateRandomLoanText($conn, $mfo, $randomKey) {
        $phrases = [
            "Если вы хотите оформить займ в МФО %s, то вы можете получить максимальную сумму займа до %s. Льготный период составляет %s, а процентная ставка равна %s. Срок займа - %s.",
            "МФО %s предлагает займы с максимальной суммой до %s. Льготный период - %s, процентная ставка - %s, срок займа - %s.",
            "Займы от МФО %s могут достигать суммы %s. Льготный период составляет %s, процентная ставка равна %s, а срок займа - %s."
        ];

        $text = "";
               while (strlen($text) < 3000) {
            $loan = $mfo[array_rand($mfo)];
            $text .= sprintf(
                $phrases[array_rand($phrases)],
                $loan['Название'],
                generateRandomMaxLoanAmount(),
                generateRandomGracePeriod(),
                generateRandomInterestRate(),
                generateRandomLoanTerm()
            ) . " ";
        }

        // Разделение текста на два блока для вставки заголовка h3 после завершения предложения
        $middlePos = strrpos(substr($text, 0, strlen($text) / 2), '.');
        $text = substr($text, 0, $middlePos + 1) . "<h3>$randomKey</h3>" . substr($text, $middlePos + 1);

        // Добавление второго заголовка h3 перед маркированным списком
        $randomKey2 = getRandomRow($conn, 'Key_MFO')['Ключ'];
        $text .= "<h3>$randomKey2</h3>";

        // С вероятностью 30% добавить заголовок h4
        if (rand(1, 100) <= 30) {
            $randomKey3 = getRandomRow($conn, 'Key_MFO')['Ключ'];
            $text .= "<h4>$randomKey3</h4>";
        }

        // Добавление маркированного списка
        $listItems = [
            "<li>Максимальная сумма займа: " . generateRandomMaxLoanAmount() . "</li>",
            "<li>Льготный период: " . generateRandomGracePeriod() . "</li>",
            "<li>Процентная ставка: " . generateRandomInterestRate() . "</li>",
            "<li>Срок займа: " . generateRandomLoanTerm() . "</li>"
        ];
        shuffle($listItems);
        $text .= "<ul>" . implode("", $listItems) . "</ul>";

        return $text;
    }

    // Функция для генерации случайного текста для страховых
    function generateRandomInsuranceText($conn, $insuranceCompany, $autoBrand) {
        $phrases = [
            "Страховая компания %s предлагает выгодные условия страхования автомобилей марки %s. Номер лицензии: %s. Номер свидетельства РСА: %s. Основной телефон: %s. Email: %s. Сайт: %s. Адрес: %s. ИНН: %s. Примерная цена полиса: %s.",
            "Компания %s предоставляет страховые услуги для автомобилей марки %s с лучшими условиями. Номер лицензии: %s. Номер свидетельства РСА: %s. Основной телефон: %s. Email: %s. Сайт: %s. Адрес: %s. ИНН: %s. Примерная цена полиса: %s.",
            "Если вы хотите застраховать автомобиль марки %s, компания %s предоставляет отличные условия. Номер лицензии: %s. Номер свидетельства РСА: %s. Основной телефон: %s. Email: %s. Сайт: %s. Адрес: %s. ИНН: %s. Примерная цена полиса: %s."
        ];

        $text = "";
        while (strlen($text) < 2000) {
            $insurance = $insuranceCompany[array_rand($insuranceCompany)];
            $auto = $autoBrand[array_rand($autoBrand)]['Марка'];
            $text .= sprintf(
                $phrases[array_rand($phrases)],
                $insurance['Страховая_компания'],
                $auto,
                $insurance['Номер_Лиц_Минфина'],
                $insurance['Номер_Свид_РСА'],
                $insurance['Основной_телефон_факс'],
                $insurance['Email'],
                $insurance['Сайт'],
                $insurance['Адрес'],
                $insurance['ИНН'],
                generateRandomInsurancePolicyPrice()
            ) . " ";
        }

        // Разделение текста на два блока для вставки заголовка h3 после завершения предложения
        $middlePos = strrpos(substr($text, 0, strlen($text) / 2), '.');
        $text = substr($text, 0, $middlePos + 1) . "<h3>" . getRandomRow($conn, 'Key_Insurance')['Ключ'] . "</h3>" . substr($text, $middlePos + 1);

        // Добавление второго заголовка h3 перед маркированным списком
        $randomKey2 = getRandomRow($conn, 'Key_Insurance')['Ключ'];
        $text .= "<h3>$randomKey2</h3>";

        // С вероятностью 30% добавить заголовок h4
        if (rand(1, 100) <= 30) {
            $randomKey3 = getRandomRow($conn, 'Key_Insurance')['Ключ'];
            $text .= "<h4>$randomKey3</h4>";
        }

        // Добавление маркированного списка
        $listItems = [
            "<li>Компания: " . $insurance['Страховая_компания'] . "</li>",
            "<li>Номер лицензии: " . $insurance['Номер_Лиц_Минфина'] . "</li>",
            "<li>Номер свидетельства РСА: " . $insurance['Номер_Свид_РСА'] . "</li>",
            "<li>Основной телефон: " . $insurance['Основной_телефон_факс'] . "</li>",
            "<li>Email: " . $insurance['Email'] . "</li>",
            "<li>Сайт: " . $insurance['Сайт'] . "</li>",
            "<li>Адрес: " . $insurance['Адрес'] . "</li>",
            "<li>ИНН: " . $insurance['ИНН'] . "</li>"
        ];
        shuffle($listItems);
        $text .= "<ul>" . implode("", $listItems) . "</ul>";

        return $text;
    }

    // Функция для генерации случайного текста по тематике МФО
    function generateRandomMFOSentences($conn, $mfo, $numSentences = 4) {
        $phrases = [
            "МФО %s предлагает займы с максимальной суммой до %s и льготным периодом %s.",
            "Процентная ставка в МФО %s составляет %s, а срок займа - %s.",
            "Оформите займ в МФО %s на сумму до %s с льготным периодом %s.",
            "МФО %s предлагает выгодные условия займа с процентной ставкой %s на срок %s."
        ];
        
        $sentences = [];
        for ($i = 0; $i < $numSentences; $i++) {
            $loan = $mfo[array_rand($mfo)];
            $sentences[] = sprintf(
                $phrases[array_rand($phrases)],
                $loan['Название'],
                generateRandomMaxLoanAmount(),
                generateRandomGracePeriod(),
                generateRandomInterestRate(),
                generateRandomLoanTerm()
            );
        }
        return implode(' ', $sentences);
    }

    // Получение случайных ключей
    $keyMFO = getRandomRow($conn, 'Key_MFO')['Ключ'];
    $keyInsurance = getRandomRow($conn, 'Key_Insurance')['Ключ'];
    $keyBanks = getRandomRow($conn, 'Key_Banks')['Ключ'];
    $randomKey = getRandomRow($conn, 'Key_Banks')['Ключ'];

    // Получение случайных данных из таблиц
    $banks = getRandomRows($conn, 'Banks');
    $mfo = getRandomRows($conn, 'MFO');
    $insurance = getRandomRows($conn, 'Insurance');
    $auto = getRandomRows($conn, 'Auto');

    // Функция для генерации HTML таблицы без столбца id
    function generateTable($data, $extraColumns = []) {
        if (empty($data)) {
            return '';
        }
        $html = '<table border="1"><tr>';
        // Заголовки столбцов (исключая 'id')
        $columns = array_keys($data[0]);
        if (($key = array_search('id', $columns)) !== false) {
            unset($columns[$key]);
        }
        foreach ($columns as $column) {
            $html .= "<th>$column</th>";
        }
        foreach ($extraColumns as $column => $header) {
            $html .= "<th>$header</th>";
        }
        $html .= '</tr>';
        // Данные строк (исключая 'id')
        foreach ($data as $row) {
            $html .= '<tr>';
            foreach ($row as $key => $cell) {
                if ($key !== 'id') {
                    $html .= "<td>$cell</td>";
                }
            }
            foreach ($extraColumns as $column => $header) {
                $html .= "<td>" . call_user_func("generateRandom$column") . "</td>";
            }
            $html .= '</tr>';
        }
        $html .= '</table>';
        return $html;
    }

       // Функция для проверки и получения данных из таблицы Links
    function getLinkByUrl($conn, $url, $linksTable) {
        $stmt = $conn->prepare("SELECT Links, Anchor FROM $linksTable WHERE Url = :url");
        $stmt->execute([':url' => $url]);
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    // Функция для получения всех ссылок из таблицы Links
    function getAllLinks($conn, $linksTable) {
        $cacheKey = "all_links_$linksTable";
        $links = getCache($cacheKey);
        if ($links === false) {
            $stmt = $conn->query("SELECT Url, Anchor, Links FROM $linksTable");
            $links = $stmt->fetchAll(PDO::FETCH_ASSOC);
            setCache($cacheKey, $links);
        }
        return $links;
    }

    // Получение URL из запроса
    $requestedUrl = ltrim($_SERVER['REQUEST_URI'], '/');

    // Проверка, начинается ли URL с цифры и существует ли он в таблице Links
    $additionalContent = '';
    $pageTitle = "$keyMFO - $keyInsurance - $keyBanks";
    $h1Content = $keyMFO;
    $linkList = '';

    if (empty($requestedUrl)) {
        // При открытии главной страницы
        $linkData = getRandomRow($conn, $linksTable);
        if ($linkData) {
            $mfoSentences = generateRandomMFOSentences($conn, $mfo);
            $additionalContent = '<p>Прочитайте про ' . $linkData['Anchor'] . ' на сайте: ' . $linkData['Links'] . '. ' . $mfoSentences . '</p>';
            $pageTitle = $linkData['Anchor'] . " - $keyInsurance - $keyBanks";
            $h1Content = $linkData['Anchor'];
        }
    } else {
        // При открытии любой другой страницы кроме главной
        if (is_numeric($requestedUrl)) {
            $linkData = getLinkByUrl($conn, $requestedUrl, $linksTable);
            if ($linkData) {
                $additionalContent = '<p>Прочитайте про ' . $linkData['Anchor'] . ' на сайте: ' . $linkData['Links'] . '.</p>';
                $pageTitle = $linkData['Anchor'] . " - $keyInsurance - $keyBanks";
                $h1Content = $linkData['Anchor'];
            }
        }
    }

    // Генерация случайных URL для списка
    function generateRandomUrl() {
        $letters = chr(rand(97, 122)) . chr(rand(97, 122));
        $digits = rand(100, 999);
        return "$letters-$digits";
    }

    // Функция для генерации случайных внешних URL
    function generateRandomExternalUrl() {
        $letters = chr(rand(97, 122)) . chr(rand(97, 122)) . chr(rand(48, 57));
        $domains = ['ru', 'com', 'net', 'org', 'info'];
        $domain = $domains[array_rand($domains)];
        return "https://$letters.$domain";
    }

    // Генерация случайного количества URL (от 5 до 15)
    $numUrls = rand(5, 15);
    $randomUrls = [];
    for ($i = 0; $i < $numUrls; $i++) {
        $randomUrls[] = generateRandomUrl();
    }

    // Вставка случайного внешнего URL с вероятностью 1%
    if (rand(1, 100) <= 1) {
        $externalUrl = generateRandomExternalUrl();
        $randomUrls = array_merge([$externalUrl], $randomUrls);
    }

    // Форматирование URL в HTML список
    $htmlListItems = '';
    foreach ($randomUrls as $url) {
        // Проверка, является ли URL внешним
        if (strpos($url, 'https://') === 0) {
            $htmlListItems .= '<li><a href="' . $url . '">' . $url . '</a></li>';
        } else {
            $htmlListItems .= '<li><a href="/' . $url . '">' . $url . '</a></li>';
        }
    }

    // Завершенный HTML список
    $htmlList = '<ul>' . $htmlListItems . '</ul>';

    // Генерация случайных стилей
    function generateRandomStyle() {
        $fonts = ['Arial', 'Verdana', 'Tahoma', 'Georgia', 'Times New Roman'];
        $font = $fonts[array_rand($fonts)];
        $fontSize = rand(16, 20) . 'px';
        $margin = rand(5, 15) . 'px 0';

        return "font-family: $font; font-size: $fontSize; margin: $margin;";
    }

    $styleH1 = generateRandomStyle();
    $styleH2 = generateRandomStyle();
    $styleP = generateRandomStyle();

    // Формирование HTML страницы
    $html = "<!DOCTYPE html>
    <html lang='ru'>
    <head>
        <meta charset='UTF-8'>
        <title>$pageTitle</title>
        <style>
            h1 { $styleH1 }
            h2 { $styleH2 }
            p { $styleP }
        </style>
    </head>
    <body>
        <h1>$h1Content</h1>
        $additionalContent
        <a href='/'><h2>$keyBanks</h2></a>
        " . generateTable($banks, ['CreditLimit' => 'Кредитный лимит', 'GracePeriod' => 'Льготный период', 'AnnualFee' => 'Годовое обслуживание', 'InterestRate' => 'Процентная ставка', 'Cashback' => 'Кэшбэк']) . "
        <h2>" . getRandomRow($conn, 'Key_Banks')['Ключ'] . "</h2>
        <p>" . generateRandomBankText($conn, $banks, $randomKey) . "</p>
        <a href='/'><h2>$keyMFO</h2></a>
        " . generateTable($mfo, ['MaxLoanAmount' => 'Максимальная сумма займа', 'GracePeriod' => 'Льготный период', 'InterestRate' => 'Процентная ставка', 'LoanTerm' => 'Срок займа']) . "
        <h2>" . getRandomRow($conn, 'Key_MFO')['Ключ'] . "</h2>
        <p>" . generateRandomLoanText($conn, $mfo, $randomKey) . "</p>
        <a href='/'><h2>$keyInsurance</h2></a>
        " . generateTable($insurance) . "
        <h2>" . getRandomRow($conn, 'Key_Insurance')['Ключ'] . "</h2>
        <p>" . generateRandomInsuranceText($conn, $insurance, $auto) . "</p>
        $htmlList
    </body>
    </html>";

    echo $html;

} catch(PDOException $e) {
    echo "Ошибка: " . $e->getMessage();
}

$conn = null;
?>
